## loki-ecmwf 0.2.1

=== CMakeLists.txt ===
# (C) Copyright 2018- ECMWF.
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

##############################################################################
#.rst:
#
# loki
# ====
#
# Install Loki with dependencies. ::
#
# Features
# --------
#
# :NO_INSTALL:  Do not install Loki itself but make the CMake configuration
#               available (Default: ``OFF``)
# :EDITABLE:    Install Loki as an editable package (Default: ``OFF``)
# :CLAW:        Install CLAW and OMNI Compiler (Default: ``OFF``)
#
# Installation procedure
# ----------------------
#
# A virtual environment is created for Loki into which it is installed along
# with any dependencies. The CLI scripts ``loki-transform.py`` and ``loki-lint.py``
# are made available as executable targets, thus can be used from any subsequent
# ``add_custom_command`` statements.
#
##############################################################################

# Version 3.12 required to use FindPython
# Version 3.15 officially required to use Python3_FIND_VIRTUALENV (not working on 3.15.3,
# though, and use 3.17 for conda support anyway)
cmake_minimum_required( VERSION 3.17 FATAL_ERROR )
find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )

# Specify project and configuration options
project( loki LANGUAGES NONE )

# Allow negating ENABLE_NO_INSTALL with a leading '~'
macro( apply_negation VAR_NAME )
    if( DEFINED ${VAR_NAME} )
        if( ${${VAR_NAME}} MATCHES ^~ )
            string( REPLACE ~ "" ${VAR_NAME} ${${VAR_NAME}} )
            if( ${${VAR_NAME}} )
                set( ${VAR_NAME} OFF )
            else()
                set( ${VAR_NAME} ON )
            endif()
        endif()
    endif()
endmacro()

apply_negation( ENABLE_NO_INSTALL )
apply_negation( LOKI_ENABLE_NO_INSTALL )

# Declare options
ecbuild_add_option(
    FEATURE NO_INSTALL
    DEFAULT OFF
    DESCRIPTION "Disable Loki (and dependency) installation"
)
ecbuild_add_option(
    FEATURE EDITABLE
    DEFAULT OFF
    DESCRIPTION "Install Loki as an editable Python package"
)
ecbuild_add_option(
    FEATURE CLAW
    DEFAULT OFF
    DESCRIPTION "Build OMNI Compiler and CLAW Compiler"
)

include( loki_transform )

# Make CMake script files available in build and install directory
add_subdirectory( cmake )
install( DIRECTORY cmake DESTINATION ${INSTALL_DATA_DIR} PATTERN "CMakeLists.txt" EXCLUDE )

# The list of Loki frontend scripts
file( GLOB _LOKI_SCRIPTS "${CMAKE_CURRENT_SOURCE_DIR}/scripts/loki_*.py" )
list( TRANSFORM _LOKI_SCRIPTS REPLACE "scripts/loki_" "scripts/loki-" )
set( LOKI_EXECUTABLES "" )
foreach( _exe IN LISTS _LOKI_SCRIPTS )
    get_filename_component( _exe_name ${_exe} NAME )
    list( APPEND LOKI_EXECUTABLES ${_exe_name} )
endforeach()

# Install Loki and dependencies
if( NOT HAVE_NO_INSTALL )

    if( HAVE_CLAW )
        include( claw_compiler )
        install_claw_compiler( mlange-dev )
    endif()

    # Setup Python virtual environment
    include( python_venv )
    set( loki_VENV_PATH ${CMAKE_CURRENT_BINARY_DIR}/loki_env )
    setup_python_venv( ${loki_VENV_PATH} )
    install( DIRECTORY ${loki_VENV_PATH} DESTINATION . USE_SOURCE_PERMISSIONS )

    # Enable Pytest tests as ecbuild/ctest targets
    if( HAVE_TESTS )

        if( HAVE_CLAW )
            set( _TEST_SELECTOR "not ofp" )
            set( _TEST_PATH "${CLAW_DIR}/bin:$ENV{PATH}" )
        else()
            set( _TEST_SELECTOR "not ofp and not omni" )
            set( _TEST_PATH "$ENV{PATH}" )
        endif()

        # ecbuild_add_test relies on the variables set by the _very_ outdated
        # FindPythonInterp, so we set the bare minimum here using the values
        # from our FindPython3 variables
        set( PYTHONINTERP_FOUND True )
        set( PYTHON_EXECUTABLE ${Python3_EXECUTABLE} )

        ecbuild_add_test(
            TYPE PYTHON
            TARGET loki_tests
            ARGS -m pytest -k ${_TEST_SELECTOR} -v
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests
            ENVIRONMENT PATH=${Python3_VENV_BIN}:${_TEST_PATH}
        )

        ecbuild_add_test(
            TYPE PYTHON
            TARGET loki_transformations
            ARGS -m pytest -k ${_TEST_SELECTOR} -v
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/transformations/tests
            ENVIRONMENT PATH=${Python3_VENV_BIN}:${_TEST_PATH}
        )

        ecbuild_add_test(
            TYPE PYTHON
            TARGET loki_lint_rules
            ARGS -m pytest -k ${_TEST_SELECTOR} -v
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/lint_rules/tests
            ENVIRONMENT PATH=${Python3_VENV_BIN}:${_TEST_PATH}
        )

        list( APPEND LOKI_INSTALL_OPTIONS "tests" )

    endif()

    # Install Loki python package with dependencies
    if( NOT ${CMAKE_VERBOSE_MAKEFILE} )
        # Less verbose output
        list ( APPEND PIP_OPTIONS "-q" )
    endif()
    execute_process( COMMAND ${Python3_EXECUTABLE} -m pip install --upgrade ${PIP_OPTIONS} pip )

    if( HAVE_EDITABLE )
        # Use checked-out source instead of installing into venv
        list( APPEND PIP_OPTIONS "-e" )
    endif()

    set( _INSTALL_OPTIONS "" )
    if( LOKI_INSTALL_OPTIONS )
        list( JOIN LOKI_INSTALL_OPTIONS "," _INSTALL_OPT_STR )
        set( _INSTALL_OPTIONS "[${_INSTALL_OPT_STR}]" )
    endif()

    # We install Loki at configure time (for now), since bulk-transformation planning
    # requires configure time execution to allow injection with CMake targets.

    message( STATUS "Install Loki in virtual environment" )
    execute_process( COMMAND ${Python3_EXECUTABLE} -m pip install ${PIP_OPTIONS} ${CMAKE_CURRENT_SOURCE_DIR}${_INSTALL_OPTIONS} )
    message( STATUS "Install Loki in virtual environment - done" )

    message( STATUS "Install Loki transformations in virtual environment" )
    execute_process( COMMAND ${Python3_EXECUTABLE} -m pip install ${PIP_OPTIONS} ${CMAKE_CURRENT_SOURCE_DIR}/transformations )
    message( STATUS "Install Loki transformations in virtual environment - done" )

    message( STATUS "Install Loki lint_rules in virtual environment" )
    execute_process( COMMAND ${Python3_EXECUTABLE} -m pip install ${PIP_OPTIONS} ${CMAKE_CURRENT_SOURCE_DIR}/lint_rules )
    message( STATUS "Install Loki lint_rules in virtual environment - done" )

    # Make the shebang in Python scripts use relative paths
    list(
        TRANSFORM LOKI_EXECUTABLES
        PREPEND ${Python3_VENV_BIN}/
        OUTPUT_VARIABLE _venv_executables
    )
    update_python_shebang( ${_venv_executables} )

endif()

# Discover Loki executables and make available as CMake targets
include( loki_find_executables )
loki_find_executables()

# Install the project so it can be used within the bundle
ecbuild_install_project( NAME loki )

# print summary
ecbuild_print_summary()

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = source
BUILDDIR      = build

SPHINXAPIDOC ?= sphinx-apidoc

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile apidoc

apidoc:
	@$(SPHINXAPIDOC) -o "$(SOURCEDIR)" -e --no-toc -f ../loki

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile apidoc
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== cmake/cmake-jdk-ant/CMakeLists.txt ===
# (C) Copyright 2018- ECMWF.
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

# CMake 3.10 required to parse Java version
# CMake 3.14 required to use FetchContent_MakeAvailable
cmake_minimum_required( VERSION 3.14 )
project( cmake-jdk-ant VERSION 0.1 LANGUAGES NONE )

set( MINIMUM_JAVA_VERSION 11 CACHE STRING "Minimum Java version required" )
set( MINIMUM_ANT_VERSION 1.10 CACHE STRING "Minimum ant version required" )

set( FORCE_OPEN_JDK_INSTALL OFF CACHE BOOL "Force installation of OpenJDK" )
set( FORCE_ANT_INSTALL OFF CACHE BOOL "Force installation of OpenJDK" )

set( OPEN_JDK_INSTALL_VERSION 11.0.2 CACHE STRING "OpenJDK version to install if Java >= ${MINIMUM_JAVA_VERSION} not found" )
set( OPEN_JDK_MIRROR https://download.java.net/java/GA/jdk11/9/GPL/ CACHE STRING "OpenJDK download mirror" )

set( ANT_INSTALL_VERSION 1.10.12 CACHE STRING "ant version to install if Ant >= ${MINIMUM_ANT_VERSION} not found" )
set( ANT_MIRROR https://archive.apache.org/dist/ant/binaries/ CACHE STRING "ant download mirror" )

list( APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/module" )

include( FetchContent )

find_package( Java ${MINIMUM_JAVA_VERSION} COMPONENTS Development )

if( NOT Java_FOUND OR FORCE_OPEN_JDK_INSTALL )

    # Remove variables from cache to make sure find_package(Java) works correctly later
    unset( JAVA_HOME CACHE )
    unset( Java_JAVA_EXECUTABLE CACHE )

    # Use FetchContent to make available at configure time instead of build time (as would be the case with ExternalProject_Add)
    FetchContent_Declare(
        OpenJDK
        URL ${OPEN_JDK_MIRROR}/openjdk-${OPEN_JDK_INSTALL_VERSION}_linux-x64_bin.tar.gz
    )

    list( APPEND FETCH_CONTENT_LIST "OpenJDK" )
    message( STATUS "OpenJDK: Download and install version ${OPEN_JDK_INSTALL_VERSION}" )

elseif( DEFINED ENV{JAVA_HOME} )

    set( JAVA_HOME $ENV{JAVA_HOME} CACHE STRING "" )

endif()

find_package( Ant ${MINIMUM_ANT_VERSION} )

if( NOT Ant_FOUND OR FORCE_ANT_INSTALL )

    # Remove variables from cache to make sure find_package(Ant) works correctly later
    unset( ANT_HOME CACHE )
    unset( Ant_EXECUTABLE CACHE )

    # Use FetchContent to make available at configure time instead of build time (as would be the case with ExternalProject_Add)
    FetchContent_Declare(
        Ant
        URL ${ANT_MIRROR}/apache-ant-${ANT_INSTALL_VERSION}-bin.tar.gz
    )

    list( APPEND FETCH_CONTENT_LIST "Ant" )
    message( STATUS "Ant: Download and install version ${ANT_INSTALL_VERSION}" )

endif()

if( FETCH_CONTENT_LIST )

    # Trigger the actual downloads
    FetchContent_MakeAvailable ( ${FETCH_CONTENT_LIST} )

    # Re-discover Java
    if( "OpenJDK" IN_LIST FETCH_CONTENT_LIST )
        FetchContent_GetProperties( OpenJDK SOURCE_DIR OPEN_JDK_SOURCE_DIR BINARY_DIR OPEN_JDK_BINARY_DIR )

        # Create wrapper scripts that set JAVA_HOME for Java binaries
        file( MAKE_DIRECTORY "${OPEN_JDK_BINARY_DIR}/bin" )
        foreach( _JAVA_BINARY java javac javah jar javadoc )
            file(
                WRITE "${OPEN_JDK_SOURCE_DIR}/${_JAVA_BINARY}"
                "#!/bin/bash
                JAVA_HOME=${OPEN_JDK_SOURCE_DIR} ${OPEN_JDK_SOURCE_DIR}/bin/${_JAVA_BINARY} \"$@\""
            )
            file(
                COPY "${OPEN_JDK_SOURCE_DIR}/${_JAVA_BINARY}"
                DESTINATION "${OPEN_JDK_BINARY_DIR}/bin"
                FILE_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
            )
        endforeach()

        # Re-discover Java
        set( JAVA_HOME ${OPEN_JDK_BINARY_DIR} CACHE STRING "" )
        find_package( Java ${OPEN_JDK_INSTALL_VERSION} EXACT REQUIRED COMPONENTS Development )
    endif()

    # Re-discover Ant and fetch dependencies
    if( "Ant" IN_LIST FETCH_CONTENT_LIST )
        FetchContent_GetProperties( Ant SOURCE_DIR ANT_SOURCE_DIR BINARY_DIR ANT_BINARY_DIR )

        if( JAVA_HOME )
            set( _JAVA_HOME "JAVA_HOME=${JAVA_HOME}" )
        elseif( DEFINED ENV{JAVA_HOME} )
            set( _JAVA_HOME "JAVA_HOME=$ENV{JAVA_HOME}" )
        else()
            set( _JAVA_HOME "" )
        endif()

        # Create a wrapper script that sets ANT_HOME
        file(
            WRITE "${ANT_SOURCE_DIR}/ant"
            "#!/bin/bash
            ANT_HOME=${ANT_SOURCE_DIR} ${_JAVA_HOME} ${ANT_SOURCE_DIR}/bin/ant \"$@\""
        )
        file( MAKE_DIRECTORY "${ANT_BINARY_DIR}/bin" )
        file(
            COPY "${ANT_SOURCE_DIR}/ant"
            DESTINATION "${ANT_BINARY_DIR}/bin"
            FILE_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
        )

        # Download dependencies
        message( STATUS "Ant: Fetch dependencies" )
        execute_process( COMMAND "${ANT_BINARY_DIR}/bin/ant" -f "${ANT_SOURCE_DIR}/fetch.xml" -Ddest=optional OUTPUT_QUIET )

        # Re-discover ant
        set( ANT_HOME ${ANT_BINARY_DIR} CACHE STRING "" )
        find_package( Ant ${ANT_INSTALL_VERSION} EXACT REQUIRED )
    endif()

endif()

message ( VERBOSE "JAVA_HOME=\"${JAVA_HOME}\"" )
message ( VERBOSE "ANT_HOME=\"${ANT_HOME}\"" )

=== debian/changelog ===
loki-ecmwf (0.2.1-2) unstable; urgency=medium

  * Fix py3dist-overrides for incorrect dep on python3-loki.
    Closes: #1069631

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 22 Apr 2024 09:43:41 +0100

loki-ecmwf (0.2.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 28 Mar 2024 08:04:41 +0000

loki-ecmwf (0.2.0-1) unstable; urgency=medium

  * New upstream release
  * Add python depends to python3-loki-ecmwf-lint-rules, python3-loki-
    ecmwf-transformations

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 24 Mar 2024 09:18:34 +0000

loki-ecmwf (0.1.6-4) unstable; urgency=medium

  * Substvars creates incorrect deps on 'python3-loki'.
    Hard-code python3-loki-ecmwf

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 04 Mar 2024 14:52:11 +0000

loki-ecmwf (0.1.6-3) unstable; urgency=medium

  * Fix VCS refs in d/control to science-team

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 25 Feb 2024 08:44:12 +0000

loki-ecmwf (0.1.6-2) unstable; urgency=medium

  * Build-dep on pybuild-plugin-pyproject, python3-sphinx-rtd-theme,
    pandoc
  * add d/py3dist-overrides file
  * Add debian/* to d/copyright
  * Fix call to make docs: PYTHONPATH needs to be set
  * Fix typo that breaks privacy-breach replace in d/rules

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 18 Feb 2024 12:58:35 +0000

loki-ecmwf (0.1.6-1) experimental; urgency=medium

  * Initial release. (Closes: #1061367)

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 02 Feb 2024 13:19:21 +0000

=== debian/control ===
Source: loki-ecmwf
Section: python
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-sequence-python3,
 dh-sequence-sphinxdoc <!nodoc>,
 python3-setuptools,
 python3-setuptools-scm,
 python3-setuptools-whl,
 pybuild-plugin-pyproject,
 python3-all, 
 python3-numpy,
 python3-codetiming,
 python3-pydantic,
 python3-nbconvert <!nocheck>,
 python3-pandas <!nocheck>,
 python3-pytest <!nocheck>,
 python3-pytest-cov <!nocheck>,
 pylint <!nocheck>,
 pandoc <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-nbsphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
 python3-recommonmark <!nodoc>,
 python3-myst-parser <!nodoc>,
 python3-sphinx-design <!nodoc>
X-Python3-Version: >= 3.10
Standards-Version: 4.6.2
Homepage: https://github.com/ecmwf-ifs/loki
Vcs-Browser: https://salsa.debian.org/science-team/loki-ecmwf.git
Vcs-Git: https://salsa.debian.org/science-team/loki-ecmwf.git

Package: python3-loki-ecmwf
Architecture: all
Depends: ${python3:Depends}
Recommends: python3-loki-ecmwf-doc,
 python3-loki-ecmwf-transformations,
 python3-loki-ecmwf-lint-rules
Description: Source-to-source translation for Fortran
 Loki is an experimental tool to explore the possible use of source-to-source
 translation for ECMWF's Integrated Forecasting System (IFS) and associated
 Fortran software packages.
 .
 Loki is based on compiler technology (visitor patterns and ASTs) and aims
 to provide an abstract, language-agnostic representation of a kernel,
 as well as a programmable (pythonic) interface that allows developers
 to experiment with different kernel implementations and optimizations.
 The aim is to allow changes to programming models and coding styles
 to be encoded and automated instead of hand-applying them, enabling
 advanced experimentation with large kernels as well as bulk processing
 of large numbers of source files to evaluate different kernel implementations
 and programming models.

Package: python3-loki-ecmwf-doc
Architecture: all
Depends:  ${sphinxdoc:Depends},
         libjs-mathjax,
         libjs-requirejs
Built-Using: ${sphinxdoc:Built-Using}
Description: Source-to-source translation for Fortran - documentation
 Loki is an experimental tool to explore the possible use of source-to-source
 translation for ECMWF's Integrated Forecasting System (IFS) and associated
 Fortran software packages.
 .
 This package contains the HTML documentation for Loki.

Package: python3-loki-ecmwf-transformations
Architecture: all
Depends: ${python3:Depends}
Description: Source-to-source translation for Fortran - IFS transformations
 Loki is an experimental tool to explore the possible use of source-to-source
 translation for ECMWF's Integrated Forecasting System (IFS) and associated
 Fortran software packages.
 .
 This package contains the IFS transformation implementations for Loki.

Package: python3-loki-ecmwf-lint-rules
Architecture: all
Depends:  ${python3:Depends}
Description: Source-to-source translation for Fortran - Lint rules
 Loki is an experimental tool to explore the possible use of source-to-source
 translation for ECMWF's Integrated Forecasting System (IFS) and associated
 Fortran software packages.
 .
 This package contains the Lint rules for the loki-lint tool.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export PYBUILD_SYSTEM=pyproject
export SETUPTOOLS_SCM_PRETEND_VERSION=$(DEB_VERSION_UPSTREAM)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

DESTDIR:=$(CURDIR)/debian/python3-loki-ecmwf

# magic debhelper rule
%:
	dh $@ --buildsystem=pybuild  --with python3,sphinxdoc 

override_dh_auto_configure:
	dh_auto_configure
	(cd loki; ln -s ../scripts )

override_dh_auto_build:
	PYBUILD_NAME=loki-ecmwf dh_auto_build -O--buildsystem=pybuild
	PYBUILD_NAME=loki-ecmwf-transformations	dh_auto_build -O--buildsystem=pybuild --sourcedirectory=transformations
	PYBUILD_NAME=loki-ecmwf-lint-rules dh_auto_build -O--buildsystem=pybuild --sourcedirectory=lint_rules
	PYTHONPATH=$(CURDIR) $(MAKE) -C docs html

override_dh_auto_install:
	PYBUILD_NAME=loki-ecmwf	dh_auto_install -O--buildsystem=pybuild
	PYBUILD_NAME=loki-ecmwf-transformations	dh_auto_install -O--buildsystem=pybuild --sourcedirectory=transformations
	PYBUILD_NAME=loki-ecmwf-lint-rules	dh_auto_install -O--buildsystem=pybuild --sourcedirectory=lint_rules
	mv $(DESTDIR)/usr/bin/loki-lint.py  $(DESTDIR)/usr/bin/loki-lint
	mv $(DESTDIR)/usr/bin/loki-transform.py $(DESTDIR)/usr/bin/loki-transform

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
override_dh_sphinxdoc:
	dh_sphinxdoc --exclude=MathJax.js
	find debian/python3-loki-ecmwf-doc -name '*.html' \
	 -exec grep require.js {} /dev/null \; | cut -f1 -d: | while read r; do \
	sed -e 's%https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4% file:/usr/share/javascript/requirejs%' \
	< $$r > debian/tmp/x ; \
	mv debian/tmp/x $$r ; \
	done
endif

override_dh_auto_test:
	@echo Skip tests this build

=== debian/watch ===
version=4
opts="uversionmangle=s/-rc/~rc/, filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/" \
  https://github.com/ecmwf-ifs/loki/tags .*/v?(\d\d?\d?\..+).tar\.gz

## loki-ecmwf 0.2.2

=== debian/changelog ===
loki-ecmwf (0.2.2-1) unstable; urgency=medium

  * New upstream release
  * Add misc:Depends for debhelper
  * Set Debian Science Maint. as maintainer
  * Standards-Version: 4.7.0; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 30 Apr 2024 08:12:33 +0100

## loki-ecmwf 0.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -148,6 +148,12 @@
 
     endif()
 
+    # Determine whether this is a Git worktree or if we have to provide
+    # the version number to setuptools_scm
+    if( NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git )
+        set( ENV{SETUPTOOLS_SCM_PRETEND_VERSION} ${loki_VERSION} )
+    endif()
+
     # Install Loki python package with dependencies
     if( NOT ${CMAKE_VERBOSE_MAKEFILE} )
         # Less verbose output

=== debian/changelog ===
loki-ecmwf (0.2.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 07 May 2024 09:29:48 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: loki-ecmwf
 Section: python
 Priority: optional
-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13),
  dh-sequence-python3,
  dh-sequence-sphinxdoc <!nodoc>,
@@ -26,14 +27,14 @@
  python3-myst-parser <!nodoc>,
  python3-sphinx-design <!nodoc>
 X-Python3-Version: >= 3.10
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/ecmwf-ifs/loki
 Vcs-Browser: https://salsa.debian.org/science-team/loki-ecmwf.git
 Vcs-Git: https://salsa.debian.org/science-team/loki-ecmwf.git
 
 Package: python3-loki-ecmwf
 Architecture: all
-Depends: ${python3:Depends}
+Depends: ${python3:Depends}, ${misc:Depends}
 Recommends: python3-loki-ecmwf-doc,
  python3-loki-ecmwf-transformations,
  python3-loki-ecmwf-lint-rules
@@ -55,6 +56,7 @@
 Package: python3-loki-ecmwf-doc
 Architecture: all
 Depends:  ${sphinxdoc:Depends},
+	 ${misc:Depends},
          libjs-mathjax,
          libjs-requirejs
 Built-Using: ${sphinxdoc:Built-Using}
@@ -67,7 +69,7 @@
 
 Package: python3-loki-ecmwf-transformations
 Architecture: all
-Depends: ${python3:Depends}
+Depends: ${python3:Depends},${misc:Depends}
 Description: Source-to-source translation for Fortran - IFS transformations
  Loki is an experimental tool to explore the possible use of source-to-source
  translation for ECMWF's Integrated Forecasting System (IFS) and associated
@@ -77,7 +79,7 @@
 
 Package: python3-loki-ecmwf-lint-rules
 Architecture: all
-Depends:  ${python3:Depends}
+Depends:  ${python3:Depends},${misc:Depends}
 Description: Source-to-source translation for Fortran - Lint rules
  Loki is an experimental tool to explore the possible use of source-to-source
  translation for ECMWF's Integrated Forecasting System (IFS) and associated

## loki-ecmwf 0.2.6

=== debian/changelog ===
loki-ecmwf (0.2.6-1) unstable; urgency=medium

  * New upstream release. Closes: #1078288

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 24 Aug 2024 08:34:43 +0100

=== debian/rules ===
--- 
+++ 
@@ -23,13 +23,14 @@
 
 override_dh_auto_build:
 	PYBUILD_NAME=loki-ecmwf dh_auto_build -O--buildsystem=pybuild
-	PYBUILD_NAME=loki-ecmwf-transformations	dh_auto_build -O--buildsystem=pybuild --sourcedirectory=transformations
+	# transformations no longer a project
+	# PYBUILD_NAME=loki-ecmwf-transformations	dh_auto_build -O--buildsystem=pybuild --sourcedirectory=loki/transformations
 	PYBUILD_NAME=loki-ecmwf-lint-rules dh_auto_build -O--buildsystem=pybuild --sourcedirectory=lint_rules
 	PYTHONPATH=$(CURDIR) $(MAKE) -C docs html
 
 override_dh_auto_install:
 	PYBUILD_NAME=loki-ecmwf	dh_auto_install -O--buildsystem=pybuild
-	PYBUILD_NAME=loki-ecmwf-transformations	dh_auto_install -O--buildsystem=pybuild --sourcedirectory=transformations
+	PYBUILD_NAME=loki-ecmwf-transformations	dh_auto_install -O--buildsystem=pybuild --sourcedirectory=loki/transformations
 	PYBUILD_NAME=loki-ecmwf-lint-rules	dh_auto_install -O--buildsystem=pybuild --sourcedirectory=lint_rules
 	mv $(DESTDIR)/usr/bin/loki-lint.py  $(DESTDIR)/usr/bin/loki-lint
 	mv $(DESTDIR)/usr/bin/loki-transform.py $(DESTDIR)/usr/bin/loki-transform

## loki-ecmwf 0.2.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -34,8 +34,9 @@
 # Version 3.12 required to use FindPython
 # Version 3.15 officially required to use Python3_FIND_VIRTUALENV (not working on 3.15.3,
 # though, and use 3.17 for conda support anyway)
-cmake_minimum_required( VERSION 3.17 FATAL_ERROR )
-find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )
+# Version 3.19 for support of find_package version range and file(CHMOD)
+cmake_minimum_required( VERSION 3.19 FATAL_ERROR )
+find_package( ecbuild 3.7 REQUIRED )
 
 # Specify project and configuration options
 project( loki LANGUAGES NONE )
@@ -100,7 +101,8 @@
     # Setup Python virtual environment
     include( python_venv )
     set( loki_VENV_PATH ${CMAKE_CURRENT_BINARY_DIR}/loki_env )
-    setup_python_venv( ${loki_VENV_PATH} )
+    set( PYTHON_VERSION 3.8...<3.12 )
+    setup_python_venv( ${loki_VENV_PATH} ${PYTHON_VERSION} )
     install( DIRECTORY ${loki_VENV_PATH} DESTINATION . USE_SOURCE_PERMISSIONS )
 
     # Enable Pytest tests as ecbuild/ctest targets
@@ -114,6 +116,10 @@
             set( _TEST_PATH "$ENV{PATH}" )
         endif()
 
+        # Nesting the CMake tests into CTest does not correctly resolve
+        # search paths, therefore these are getting disabled here
+        set( _TEST_SELECTOR "${_TEST_SELECTOR} and not cmake")
+
         # ecbuild_add_test relies on the variables set by the _very_ outdated
         # FindPythonInterp, so we set the bare minimum here using the values
         # from our FindPython3 variables
@@ -124,15 +130,7 @@
             TYPE PYTHON
             TARGET loki_tests
             ARGS -m pytest -k ${_TEST_SELECTOR} -v
-            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests
-            ENVIRONMENT PATH=${Python3_VENV_BIN}:${_TEST_PATH}
-        )
-
-        ecbuild_add_test(
-            TYPE PYTHON
-            TARGET loki_transformations
-            ARGS -m pytest -k ${_TEST_SELECTOR} -v
-            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/transformations/tests
+            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
             ENVIRONMENT PATH=${Python3_VENV_BIN}:${_TEST_PATH}
         )
 
@@ -140,7 +138,7 @@
             TYPE PYTHON
             TARGET loki_lint_rules
             ARGS -m pytest -k ${_TEST_SELECTOR} -v
-            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/lint_rules/tests
+            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/lint_rules
             ENVIRONMENT PATH=${Python3_VENV_BIN}:${_TEST_PATH}
         )
 
@@ -175,17 +173,13 @@
     # We install Loki at configure time (for now), since bulk-transformation planning
     # requires configure time execution to allow injection with CMake targets.
 
-    message( STATUS "Install Loki in virtual environment" )
+    ecbuild_info( "Install Loki in virtual environment" )
     execute_process( COMMAND ${Python3_EXECUTABLE} -m pip install ${PIP_OPTIONS} ${CMAKE_CURRENT_SOURCE_DIR}${_INSTALL_OPTIONS} )
-    message( STATUS "Install Loki in virtual environment - done" )
-
-    message( STATUS "Install Loki transformations in virtual environment" )
-    execute_process( COMMAND ${Python3_EXECUTABLE} -m pip install ${PIP_OPTIONS} ${CMAKE_CURRENT_SOURCE_DIR}/transformations )
-    message( STATUS "Install Loki transformations in virtual environment - done" )
-
-    message( STATUS "Install Loki lint_rules in virtual environment" )
+    ecbuild_info( "Install Loki in virtual environment - done" )
+
+    ecbuild_info( "Install Loki lint_rules in virtual environment" )
     execute_process( COMMAND ${Python3_EXECUTABLE} -m pip install ${PIP_OPTIONS} ${CMAKE_CURRENT_SOURCE_DIR}/lint_rules )
-    message( STATUS "Install Loki lint_rules in virtual environment - done" )
+    ecbuild_info( "Install Loki lint_rules in virtual environment - done" )
 
     # Make the shebang in Python scripts use relative paths
     list(

=== debian/changelog ===
loki-ecmwf (0.2.7-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 21 Sep 2024 08:16:08 +0100

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,8 @@
 
 override_dh_auto_configure:
 	dh_auto_configure
-	(cd loki; ln -s ../scripts )
+	# 'scripts' is too generic
+	mv scripts loki
 
 override_dh_auto_build:
 	PYBUILD_NAME=loki-ecmwf dh_auto_build -O--buildsystem=pybuild

## loki-ecmwf 0.2.8

=== debian/changelog ===
loki-ecmwf (0.2.8-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Nov 2024 06:12:27 +0000

## loki-ecmwf 0.2.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -72,7 +72,13 @@
 ecbuild_add_option(
     FEATURE CLAW
     DEFAULT OFF
-    DESCRIPTION "Build OMNI Compiler and CLAW Compiler"
+    DESCRIPTION "Build OMNI compiler and CLAW compiler"
+)
+ecbuild_add_option(
+    FEATURE OMNI
+    DEFAULT OFF
+    DESCRIPTION "Build OMNI compiler as Loki frontend"
+    CONDITION NOT HAVE_CLAW
 )
 
 include( loki_transform )
@@ -98,6 +104,11 @@
         install_claw_compiler( mlange-dev )
     endif()
 
+    if( HAVE_OMNI )
+        include( omni_compiler )
+        install_omni_compiler( master )
+    endif()
+
     # Setup Python virtual environment
     include( python_venv )
     set( loki_VENV_PATH ${CMAKE_CURRENT_BINARY_DIR}/loki_env )
@@ -111,6 +122,9 @@
         if( HAVE_CLAW )
             set( _TEST_SELECTOR "not ofp" )
             set( _TEST_PATH "${CLAW_DIR}/bin:$ENV{PATH}" )
+        elseif( HAVE_OMNI )
+            set( _TEST_SELECTOR "not ofp" )
+            set( _TEST_PATH "${OMNI_DIR}/bin:$ENV{PATH}" )
         else()
             set( _TEST_SELECTOR "not ofp and not omni" )
             set( _TEST_PATH "$ENV{PATH}" )

=== debian/changelog ===
loki-ecmwf (0.2.10-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 20 Dec 2024 16:08:49 +0000

## loki-ecmwf 0.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,6 @@
 # :NO_INSTALL:  Do not install Loki itself but make the CMake configuration
 #               available (Default: ``OFF``)
 # :EDITABLE:    Install Loki as an editable package (Default: ``OFF``)
-# :CLAW:        Install CLAW and OMNI Compiler (Default: ``OFF``)
 #
 # Installation procedure
 # ----------------------
@@ -70,15 +69,9 @@
     DESCRIPTION "Install Loki as an editable Python package"
 )
 ecbuild_add_option(
-    FEATURE CLAW
-    DEFAULT OFF
-    DESCRIPTION "Build OMNI compiler and CLAW compiler"
-)
-ecbuild_add_option(
     FEATURE OMNI
     DEFAULT OFF
     DESCRIPTION "Build OMNI compiler as Loki frontend"
-    CONDITION NOT HAVE_CLAW
 )
 
 include( loki_transform )
@@ -99,11 +92,6 @@
 # Install Loki and dependencies
 if( NOT HAVE_NO_INSTALL )
 
-    if( HAVE_CLAW )
-        include( claw_compiler )
-        install_claw_compiler( mlange-dev )
-    endif()
-
     if( HAVE_OMNI )
         include( omni_compiler )
         install_omni_compiler( master )
@@ -119,10 +107,7 @@
     # Enable Pytest tests as ecbuild/ctest targets
     if( HAVE_TESTS )
 
-        if( HAVE_CLAW )
-            set( _TEST_SELECTOR "not ofp" )
-            set( _TEST_PATH "${CLAW_DIR}/bin:$ENV{PATH}" )
-        elseif( HAVE_OMNI )
+        if( HAVE_OMNI )
             set( _TEST_SELECTOR "not ofp" )
             set( _TEST_PATH "${OMNI_DIR}/bin:$ENV{PATH}" )
         else()

=== debian/changelog ===
loki-ecmwf (0.3.0-1) unstable; urgency=medium

  * New upstream release
  * Add build-dep on python3-pcpp, pytohn3-pymbolic, python3-fparser
     needed during doc building
  * d/control: drop unused python3:Depends
  * Re-enable tests, catch errors but don't fail this release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 22 Jan 2025 12:30:08 +0000

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,10 @@
  python3-all, 
  python3-numpy,
  python3-codetiming,
+ python3-pcpp,
  python3-pydantic,
+ python3-pymbolic,
+ python3-fparser,
  python3-nbconvert <!nocheck>,
  python3-pandas <!nocheck>,
  python3-pytest <!nocheck>,
@@ -56,9 +59,7 @@
 Package: python3-loki-ecmwf-doc
 Architecture: all
 Depends:  ${sphinxdoc:Depends},
-	 ${misc:Depends},
-         libjs-mathjax,
-         libjs-requirejs
+	 ${misc:Depends}
 Built-Using: ${sphinxdoc:Built-Using}
 Description: Source-to-source translation for Fortran - documentation
  Loki is an experimental tool to explore the possible use of source-to-source
@@ -69,7 +70,7 @@
 
 Package: python3-loki-ecmwf-transformations
 Architecture: all
-Depends: ${python3:Depends},${misc:Depends}
+Depends: ${misc:Depends}
 Description: Source-to-source translation for Fortran - IFS transformations
  Loki is an experimental tool to explore the possible use of source-to-source
  translation for ECMWF's Integrated Forecasting System (IFS) and associated
@@ -79,7 +80,7 @@
 
 Package: python3-loki-ecmwf-lint-rules
 Architecture: all
-Depends:  ${python3:Depends},${misc:Depends}
+Depends:  ${misc:Depends}
 Description: Source-to-source translation for Fortran - Lint rules
  Loki is an experimental tool to explore the possible use of source-to-source
  translation for ECMWF's Integrated Forecasting System (IFS) and associated

## loki-ecmwf 0.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -100,7 +100,7 @@
     # Setup Python virtual environment
     include( python_venv )
     set( loki_VENV_PATH ${CMAKE_CURRENT_BINARY_DIR}/loki_env )
-    set( PYTHON_VERSION 3.8...<3.12 )
+    set( PYTHON_VERSION 3.8 )
     setup_python_venv( ${loki_VENV_PATH} ${PYTHON_VERSION} )
     install( DIRECTORY ${loki_VENV_PATH} DESTINATION . USE_SOURCE_PERMISSIONS )

=== debian/changelog ===
loki-ecmwf (0.3.1-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.7.2
  * Add python depends to python3- packages
  * Drop transformatons package; merged into main
  * Depend on networkx for doc building

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 24 Mar 2025 07:44:55 +0000

=== debian/control ===
--- 
+++ 
@@ -25,12 +25,13 @@
  pandoc <!nodoc>,
  python3-sphinx <!nodoc>,
  python3-nbsphinx <!nodoc>,
+ python3-networkx <!nodoc>,
  python3-sphinx-rtd-theme <!nodoc>,
  python3-recommonmark <!nodoc>,
  python3-myst-parser <!nodoc>,
  python3-sphinx-design <!nodoc>
 X-Python3-Version: >= 3.10
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/ecmwf-ifs/loki
 Vcs-Browser: https://salsa.debian.org/science-team/loki-ecmwf.git
 Vcs-Git: https://salsa.debian.org/science-team/loki-ecmwf.git
@@ -39,7 +40,6 @@
 Architecture: all
 Depends: ${python3:Depends}, ${misc:Depends}
 Recommends: python3-loki-ecmwf-doc,
- python3-loki-ecmwf-transformations,
  python3-loki-ecmwf-lint-rules
 Description: Source-to-source translation for Fortran
  Loki is an experimental tool to explore the possible use of source-to-source
@@ -68,19 +68,9 @@
  .
  This package contains the HTML documentation for Loki.
 
-Package: python3-loki-ecmwf-transformations
-Architecture: all
-Depends: ${misc:Depends}
-Description: Source-to-source translation for Fortran - IFS transformations
- Loki is an experimental tool to explore the possible use of source-to-source
- translation for ECMWF's Integrated Forecasting System (IFS) and associated
- Fortran software packages.
- .
- This package contains the IFS transformation implementations for Loki.
-
 Package: python3-loki-ecmwf-lint-rules
 Architecture: all
-Depends:  ${misc:Depends}
+Depends:  ${python3:Depends}, ${misc:Depends}
 Description: Source-to-source translation for Fortran - Lint rules
  Loki is an experimental tool to explore the possible use of source-to-source
  translation for ECMWF's Integrated Forecasting System (IFS) and associated

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 # Uncomment this to turn on verbose mode.
-# export DH_VERBOSE=1
+export DH_VERBOSE=1
 
 export PYBUILD_SYSTEM=pyproject
 export SETUPTOOLS_SCM_PRETEND_VERSION=$(DEB_VERSION_UPSTREAM)
@@ -12,6 +12,9 @@
 include /usr/share/dpkg/pkg-info.mk
 
 DESTDIR:=$(CURDIR)/debian/python3-loki-ecmwf
+
+PYTHONPATH:=$(CURDIR)
+export PYTHONPATH
 
 # magic debhelper rule
 %:
@@ -48,4 +51,4 @@
 endif
 
 override_dh_auto_test:
-	@echo Skip tests this build
+	( dh_auto_test || echo "Don't fail on tests; just capture errors" )

## loki-ecmwf 0.3.2

=== debian/changelog ===
loki-ecmwf (0.3.2-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 28 May 2025 16:01:26 +0100

## loki-ecmwf 0.3.3

=== debian/changelog ===
loki-ecmwf (0.3.3-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Aug 2025 09:21:49 +0100

loki-ecmwf (0.3.3-1) experimental; urgency=medium

  * Mark python3-loki-ecmwf-doc  as MA: foreign
  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 30 Jul 2025 12:37:45 +0100

## loki-ecmwf 0.3.4

=== debian/changelog ===
loki-ecmwf (0.3.4-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 04 Sep 2025 10:23:51 +0100

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,7 @@
 
 # magic debhelper rule
 %:
-	dh $@ --buildsystem=pybuild  --with python3,sphinxdoc 
+	dh $@ --buildsystem=pybuild  --with sphinxdoc
 
 override_dh_auto_configure:
 	dh_auto_configure

## loki-ecmwf 0.3.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -98,11 +98,13 @@
     endif()
 
     # Setup Python virtual environment
-    include( python_venv )
-    set( loki_VENV_PATH ${CMAKE_CURRENT_BINARY_DIR}/loki_env )
-    set( PYTHON_VERSION 3.8 )
-    setup_python_venv( ${loki_VENV_PATH} ${PYTHON_VERSION} )
-    install( DIRECTORY ${loki_VENV_PATH} DESTINATION . USE_SOURCE_PERMISSIONS )
+    include( loki_python_macros )
+    set( PYTHON_VERSION 3.9 )
+    loki_setup_python_venv(
+        VENV_NAME loki_env
+        PYTHON_VERSION ${PYTHON_VERSION}
+        INSTALL_VENV
+    )
 
     # Enable Pytest tests as ecbuild/ctest targets
     if( HAVE_TESTS )
@@ -152,41 +154,40 @@
     endif()
 
     # Install Loki python package with dependencies
-    if( NOT ${CMAKE_VERBOSE_MAKEFILE} )
-        # Less verbose output
-        list ( APPEND PIP_OPTIONS "-q" )
-    endif()
-    execute_process( COMMAND ${Python3_EXECUTABLE} -m pip install --upgrade ${PIP_OPTIONS} pip )
-
-    if( HAVE_EDITABLE )
-        # Use checked-out source instead of installing into venv
-        list( APPEND PIP_OPTIONS "-e" )
-    endif()
-
     set( _INSTALL_OPTIONS "" )
     if( LOKI_INSTALL_OPTIONS )
         list( JOIN LOKI_INSTALL_OPTIONS "," _INSTALL_OPT_STR )
         set( _INSTALL_OPTIONS "[${_INSTALL_OPT_STR}]" )
     endif()
 
+    # Optionally use the ARTIFACTS_DIR as wheelhouse, if provided
+    if( DEFINED ARTIFACTS_DIR )
+        set( WHEELS_DIR_OPTION WHEELS_DIR "${ARTIFACTS_DIR}" )
+    else()
+        set( WHEELS_DIR_OPTION "" )
+    endif()
+
+    if( HAVE_EDITABLE )
+       set( EDITABLE_OPTION "EDITABLE" )
+    else()
+       set( EDITABLE_OPTION "" )
+    endif()
+
     # We install Loki at configure time (for now), since bulk-transformation planning
     # requires configure time execution to allow injection with CMake targets.
 
     ecbuild_info( "Install Loki in virtual environment" )
-    execute_process( COMMAND ${Python3_EXECUTABLE} -m pip install ${PIP_OPTIONS} ${CMAKE_CURRENT_SOURCE_DIR}${_INSTALL_OPTIONS} )
+    loki_install_python_package(
+        REQUIREMENT_SPEC ${CMAKE_CURRENT_SOURCE_DIR}${_INSTALL_OPTIONS}
+        ${EDITABLE_OPTION}
+        ${WHEELS_DIR_OPTION}
+    )
+    loki_install_python_package(
+        REQUIREMENT_SPEC ${CMAKE_CURRENT_SOURCE_DIR}/lint_rules
+        ${EDITABLE_OPTION}
+        ${WHEELS_DIR_OPTION}
+    )
     ecbuild_info( "Install Loki in virtual environment - done" )
-
-    ecbuild_info( "Install Loki lint_rules in virtual environment" )
-    execute_process( COMMAND ${Python3_EXECUTABLE} -m pip install ${PIP_OPTIONS} ${CMAKE_CURRENT_SOURCE_DIR}/lint_rules )
-    ecbuild_info( "Install Loki lint_rules in virtual environment - done" )
-
-    # Make the shebang in Python scripts use relative paths
-    list(
-        TRANSFORM LOKI_EXECUTABLES
-        PREPEND ${Python3_VENV_BIN}/
-        OUTPUT_VARIABLE _venv_executables
-    )
-    update_python_shebang( ${_venv_executables} )
 
 endif()

=== cmake/CMakeLists.txt ===
# (C) Copyright 2018- ECMWF.
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

file( GLOB_RECURSE loki_support_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*" )

ecbuild_add_resources(
    TARGET ${PROJECT_NAME}_loki_support_files
    SOURCES_PACK
        ${loki_support_files}
)

=== cmake/cmake-jdk-ant/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 set( OPEN_JDK_INSTALL_VERSION 11.0.2 CACHE STRING "OpenJDK version to install if Java >= ${MINIMUM_JAVA_VERSION} not found" )
 set( OPEN_JDK_MIRROR https://download.java.net/java/GA/jdk11/9/GPL/ CACHE STRING "OpenJDK download mirror" )
 
-set( ANT_INSTALL_VERSION 1.10.12 CACHE STRING "ant version to install if Ant >= ${MINIMUM_ANT_VERSION} not found" )
+set( ANT_INSTALL_VERSION 1.10.15 CACHE STRING "ant version to install if Ant >= ${MINIMUM_ANT_VERSION} not found" )
 set( ANT_MIRROR https://archive.apache.org/dist/ant/binaries/ CACHE STRING "ant download mirror" )
 
 list( APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/module" )

=== debian/changelog ===
loki-ecmwf (0.3.5-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 20 Oct 2025 10:38:34 +0100

loki-ecmwf (0.3.4-3) unstablE; urgency=medium

  * Fix whitespace errors that break loading. Closes: #1115187

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 17 Oct 2025 12:27:51 +0100

loki-ecmwf (0.3.4-2) unstable; urgency=medium

  * Fix FTBFS due to git merge errors. Closes: #1117981

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 15 Oct 2025 06:17:05 +0100

=== debian/control ===
--- 
+++ 
@@ -58,6 +58,7 @@
 
 Package: python3-loki-ecmwf-doc
 Architecture: all
+Multi-Arch: foreign
 Depends:  ${sphinxdoc:Depends},
 	 ${misc:Depends}
 Built-Using: ${sphinxdoc:Built-Using}
